const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Vehicle_conditionsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vehicle_conditions = await db.vehicle_conditions.create(
      {
        id: data.id || undefined,

        before: data.before || null,
        after: data.after || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await vehicle_conditions.setTenant(data.tenant || null, {
      transaction,
    });

    await vehicle_conditions.setReservation(data.reservation || null, {
      transaction,
    });

    await vehicle_conditions.setAgences(data.agences || null, {
      transaction,
    });

    return vehicle_conditions;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const vehicle_conditionsData = data.map((item, index) => ({
      id: item.id || undefined,

      before: item.before || null,
      after: item.after || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const vehicle_conditions = await db.vehicle_conditions.bulkCreate(
      vehicle_conditionsData,
      { transaction },
    );

    // For each item created, replace relation files

    return vehicle_conditions;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const vehicle_conditions = await db.vehicle_conditions.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.before !== undefined) updatePayload.before = data.before;

    if (data.after !== undefined) updatePayload.after = data.after;

    updatePayload.updatedById = currentUser.id;

    await vehicle_conditions.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await vehicle_conditions.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.reservation !== undefined) {
      await vehicle_conditions.setReservation(
        data.reservation,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await vehicle_conditions.setAgences(
        data.agences,

        { transaction },
      );
    }

    return vehicle_conditions;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vehicle_conditions = await db.vehicle_conditions.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of vehicle_conditions) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of vehicle_conditions) {
        await record.destroy({ transaction });
      }
    });

    return vehicle_conditions;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const vehicle_conditions = await db.vehicle_conditions.findByPk(
      id,
      options,
    );

    await vehicle_conditions.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await vehicle_conditions.destroy({
      transaction,
    });

    return vehicle_conditions;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const vehicle_conditions = await db.vehicle_conditions.findOne(
      { where },
      { transaction },
    );

    if (!vehicle_conditions) {
      return vehicle_conditions;
    }

    const output = vehicle_conditions.get({ plain: true });

    output.tenant = await vehicle_conditions.getTenant({
      transaction,
    });

    output.reservation = await vehicle_conditions.getReservation({
      transaction,
    });

    output.agences = await vehicle_conditions.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.reservations,
        as: 'reservation',

        where: filter.reservation
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.reservation
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  ref: {
                    [Op.or]: filter.reservation
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.before) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('vehicle_conditions', 'before', filter.before),
        };
      }

      if (filter.after) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('vehicle_conditions', 'after', filter.after),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.vehicle_conditions.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('vehicle_conditions', 'before', query),
        ],
      };
    }

    const records = await db.vehicle_conditions.findAll({
      attributes: ['id', 'before'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['before', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.before,
    }));
  }
};
